
// Written by Hans de Nivelle, April 2016.

// Preprocessor contains the essential preprocessor. It does the following:
// Check for blockings that contain no variables. Return false if there is one.
// Check for substlets that imply a blocking. Remove these from the 
// clauses. If this results in an empty clause, or there is a clause
// that was already empty, then return false.

#ifndef GEOMETRIC_CONSTRAINTS_PREPROCESSOR_INCLUDED
#define GEOMETRIC_CONSTRAINTS_PREPROCESSOR_INCLUDED  1

#include <vector>
#include <iostream>

#include "subststack.h"
#include "gcsp.h"

namespace geometric 
{
namespace constraints 
{
   
   // Note that the preprocessor is essential.
   // preprocessor does not clear the substitution in advance, 
   // but it extends the substitution when it sees a unit clause. 

   bool preprocessor( gcsp& g, subststack< size_t > & theta,
                      size_t local );
      // 1 : no local checking.
      // 2 : local checking using pairs. 
       
}}

#endif

