
// Written by Hans de Nivelle, March 2016.

#include "watchlist.h"

namespace geometric
{
namespace constraints
{


   size_t geometric::constraints::watchlist::findposition( size_t k ) const
   {
      size_t lower = 0;
      size_t upper = vect. size( );

      while( upper - lower > 4 )
      {
         size_t middle = lower + ( upper - lower ) / 2;

         if( vect[ middle ] <= k )
            lower = middle;
         else
            upper = middle;
      }

      // End with linear search:

      while( lower < upper )
      {
         if( vect[ lower ] >= k )
            return lower;

         ++ lower;
      }

      return lower;
   } 


   std::ostream& operator << ( std::ostream& out, const watchlist& wl )
   {
      out << "{";
      for( auto p = wl. vect. begin( ); p != wl. vect. end( ); ++ p )
      {
         if( p != wl. vect. begin( ))
            out << ", ";
         else
            out << " ";
         out << *p;
      }
      out << " }";
      return out; 
   }


}}




