
#include "token.h"

namespace geometric {
namespace parser {

std::ostream& operator << ( std::ostream& out, token::type t )
{
   using tt = token::type;

   switch(t)
   {
   case tt::ident:             out << "ident";              break;
   case tt::number:            out << "number";             break;

   case tt::separator:         out << "separator";          break;

   case tt::leftround:         out << "leftround";          break;
   case tt::rightround:        out << "rightround";         break;
   case tt::leftcurly:         out << "leftcurly";          break;
   case tt::rightcurly:        out << "rightcurly";         break;
   case tt::leftsquare:        out << "leftsquare";         break;
   case tt::rightsquare:       out << "rightsquare";        break; 

   case tt::equals:            out << "equals";             break;
   case tt::create:            out << "create";             break;
   case tt::comma:             out << "comma";              break;
   case tt::colon:             out << "colon";              break;
   case tt::bar:               out << "bar";                break;
   case tt::semicolon:         out << "semicolon";          break;
   case tt::plus:              out << "plus";               break;
   case tt::minus:             out << "minus";              break;
   case tt::slash:             out << "slash";              break;
   case tt::dot:               out << "dot";                break;

   case tt::quotedstring:      out << "quotedstring";       break;

   case tt::name:              out << "%name";              break; 
   case tt::signature:         out << "%signature";         break;
   case tt::rulesystem:        out << "%rulesystem";        break;
   case tt::simplifiers:       out << "%simplifiers";       break;
   case tt::interpretation:    out << "%interpretation";    break;

   case tt::eof:               out << "eof";                break;
   }
   return out;
}

std::ostream& operator << ( std::ostream& out, const token& t )
{
   out << "token: " << t.t;
   out << "( " << t.i;
   if( t.s. size( ))
      out << ", " << t.s;
   out << " )";
   return out;
}

}}

