
// Written by Hans de Nivelle, December 2015.

#ifndef GEOMETRIC_PARSER_TOKENIZER_INCLUDED
#define GEOMETRIC_PARSER_TOKENIZER_INCLUDED  1

#include "../../tostring.h" 
#include "../../parser/inputstream.h"
#include "../../parser/errors.h"
#include "token.h"

namespace geometric {
namespace parser {

// True if identifier can start with character c:

inline bool startidentifier( char c )
{
   return ( c >= 'a' && c <= 'z' ) ||
          ( c >= 'A' && c <= 'Z' ) ||
          ( c == '_' );
}
 

// True if c can occur in the middle
// or at the end of an identifier:

inline bool inidentifier( char c )
{
   return ( c >= 'a' && c <= 'z' ) ||
          ( c >= 'A' && c <= 'Z' ) ||
          ( c >= '0' && c <= '9' ) ||
          ( c == '_' );
}


// True if c is among 0,1,2,3,4,5,6,7,8,9:

inline bool isdigit( char c )
{
   return c >= '0' && c <= '9';
}


inline bool iswhitespace( char c )
{
   return  c == ' ' || c == '\t' || c == '\n' || c == 0x0D;
}

   
long unsigned int make_unsigned( std::string::const_iterator p1,
                                 std::string::const_iterator p2,
                                 const ::parser::inputstream& mess );

token readtoken( ::parser::inputstream& stream );
   // Can throw ::parser::syntaxerror.


void testtokenizer( );

}}


#endif

